/* (c) Magnus Auvinen. See licence.txt in the root of the distribution for more information. */
/* If you are missing that file, acquire a complete release at teeworlds.com.                */

/*>======================<*/
/*			  */
/*===TeeKing mod by the===*/
/*			  */
/*>======================<*/

#include "teeking.h"
#include <engine/shared/config.h>

#include <game/server/player.h>

#include <game/server/gamecontext.h>
#include <game/server/entities/character.h>

#include <game/generated/protocol.h>
#include <string.h>

CGameControllerTEEKING::CGameControllerTEEKING(class CGameContext *pGameServer)
: IGameController(pGameServer)
{
	dbg_msg("server", "TEEKING constructor called.");
	// Exchange this to a string that identifies your game mode.
	// DM, TDM and CTF are reserved for teeworlds original modes.
	m_pGameType = "TeeKing";
	king_resp = 0;
	//m_GameFlags = GAMEFLAG_TEAMS; // GAMEFLAG_TEAMS makes it a two-team gamemode
}

void CGameControllerTEEKING::Tick()
{
	// this is the main part of the gamemode, this function is run every tick
	int king_count = 0;
	IGameController::Tick();
	for(int i=0; i < MAX_CLIENTS; i++)
	{
		if(!GameServer()->m_apPlayers[i])
			continue;
		if(GameServer()->m_apPlayers[i]->GetTeam() == TEAM_SPECTATORS)
			GameServer()->m_apPlayers[i]->king = 0;
		king_count += GameServer()->m_apPlayers[i]->king;
	}
	if(king_count==0)
		{
			if(king_resp == 0)
			{
				int i = rand()%MAX_CLIENTS;
				if(GameServer()->m_apPlayers[i] == false || GameServer()->m_apPlayers[i]->GetTeam() == TEAM_SPECTATORS)
					return;
				GameServer()->m_apPlayers[i]->king = rand()%16+1;
				char aBuf[512];
				str_format(aBuf,sizeof(aBuf),"New king is born. Long live %s!", Server()->ClientName(i) );
				GameServer()->SendBroadcast(aBuf, -1);
				king_resp = 300;
			}
			else king_resp--;
		}
	return;
}

void CGameControllerTEEKING::StartRound()
{
	for(int i=0; i < MAX_CLIENTS; i++)
	{
		if(!GameServer()->m_apPlayers[i])
			continue;
		GameServer()->m_apPlayers[i]->king = 0;
	}
	IGameController::StartRound();
}
